(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-dragdrop', ['exports', '@angular/core'], factory) :
    (global = global || self, factory(global['ngx-dragdrop'] = {}, global.ng.core));
}(this, (function (exports, core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxDragDropService = /** @class */ (function () {
        function NgxDragDropService() {
            this.defaultInstanceName = 'ngx-dragdrop';
            this.setDefaultInstance();
        }
        Object.defineProperty(NgxDragDropService.prototype, "instanceName", {
            get: /**
             * @return {?}
             */
            function () {
                return this.name;
            },
            set: /**
             * @param {?} name
             * @return {?}
             */
            function (name) {
                this.name = name;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgxDragDropService.prototype.setDefaultInstance = /**
         * @return {?}
         */
        function () {
            this.name = this.defaultInstanceName;
        };
        /**
         * @return {?}
         */
        NgxDragDropService.prototype.isDefaultInstance = /**
         * @return {?}
         */
        function () {
            return this.name === this.defaultInstanceName;
        };
        NgxDragDropService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxDragDropService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgxDragDropService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NgxDragDropService_Factory() { return new NgxDragDropService(); }, token: NgxDragDropService, providedIn: "root" });
        return NgxDragDropService;
    }());
    if (false) {
        /** @type {?} */
        NgxDragDropService.prototype.name;
        /** @type {?} */
        NgxDragDropService.prototype.defaultInstanceName;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxDraggableDirective = /** @class */ (function () {
        function NgxDraggableDirective(el, dragDropService, _renderer) {
            this.el = el;
            this.dragDropService = dragDropService;
            this._renderer = _renderer;
            this._isDraggable = false;
        }
        Object.defineProperty(NgxDraggableDirective.prototype, "ngxDraggable", {
            set: /**
             * @param {?} dragEnabled
             * @return {?}
             */
            function (dragEnabled) {
                /** @type {?} */
                var draggable = !!dragEnabled;
                this._renderer.setAttribute(this.el.nativeElement, 'draggable', "" + draggable);
                this._isDraggable = draggable;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDraggableDirective.prototype.onDragStart = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (this.el.nativeElement === event.target) {
                event.target.classList.add(this.ngxDraggedClass);
                event.dataTransfer.setData('data', JSON.stringify({ dd: this.ngxDragData }));
                if (this.ngxDragTag) {
                    this.dragDropService.instanceName = this.ngxDragTag;
                }
                else {
                    this.dragDropService.setDefaultInstance();
                }
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDraggableDirective.prototype.onDragEnd = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (this.el.nativeElement === event.target) {
                event.target.classList.remove(this.ngxDraggedClass);
            }
        };
        NgxDraggableDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxDraggable]'
                    },] }
        ];
        /** @nocollapse */
        NgxDraggableDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: NgxDragDropService },
            { type: core.Renderer2 }
        ]; };
        NgxDraggableDirective.propDecorators = {
            ngxDraggable: [{ type: core.Input }],
            ngxDragTag: [{ type: core.Input }],
            ngxDraggedClass: [{ type: core.Input }],
            ngxDragData: [{ type: core.Input }],
            onDragStart: [{ type: core.HostListener, args: ['dragstart', ['$event'],] }],
            onDragEnd: [{ type: core.HostListener, args: ['dragend', ['$event'],] }]
        };
        return NgxDraggableDirective;
    }());
    if (false) {
        /** @type {?} */
        NgxDraggableDirective.prototype._isDraggable;
        /** @type {?} */
        NgxDraggableDirective.prototype.ngxDragTag;
        /** @type {?} */
        NgxDraggableDirective.prototype.ngxDraggedClass;
        /** @type {?} */
        NgxDraggableDirective.prototype.ngxDragData;
        /**
         * @type {?}
         * @private
         */
        NgxDraggableDirective.prototype.el;
        /**
         * @type {?}
         * @private
         */
        NgxDraggableDirective.prototype.dragDropService;
        /**
         * @type {?}
         * @private
         */
        NgxDraggableDirective.prototype._renderer;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function IOnDropData() { }
    if (false) {
        /** @type {?} */
        IOnDropData.prototype.dragTag;
        /** @type {?} */
        IOnDropData.prototype.dragData;
        /** @type {?} */
        IOnDropData.prototype.dropData;
    }
    var NgxDroppableDirective = /** @class */ (function () {
        function NgxDroppableDirective(el, dragDropService) {
            this.el = el;
            this.dragDropService = dragDropService;
            this.ngxDroppable = new core.EventEmitter();
            this.ngxDropTags = [this.dragDropService.instanceName];
        }
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDroppableDirective.prototype.onDragEnter = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event.preventDefault) {
                event.preventDefault();
            }
            if (event.stopPropagation) {
                event.stopPropagation();
            }
            if (this.el.nativeElement === event.target) {
                if (this.ngxDropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                    event.target.classList.add(this.dragDropService.instanceName);
                }
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDroppableDirective.prototype.onDragOver = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event.preventDefault) {
                event.preventDefault();
            }
            if (event.stopPropagation) {
                event.stopPropagation();
            }
            if (this.el.nativeElement === event.target) {
                if (this.ngxDropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                    event.dataTransfer.effectAllowed = 'all';
                    event.dataTransfer.dropEffect = 'move';
                }
                else {
                    event.dataTransfer.effectAllowed = 'none';
                    event.dataTransfer.dropEffect = 'none';
                }
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDroppableDirective.prototype.onDragLeave = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event.preventDefault) {
                event.preventDefault();
            }
            if (event.stopPropagation) {
                event.stopPropagation();
            }
            if (this.el.nativeElement === event.target) {
                if (this.ngxDropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                    event.target.classList.remove(this.dragDropService.instanceName);
                }
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDroppableDirective.prototype.onDrop = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event.preventDefault) {
                event.preventDefault();
            }
            if (event.stopPropagation) {
                event.stopPropagation();
            }
            if (this.el.nativeElement === event.target) {
                /** @type {?} */
                var dragTag = this.dragDropService.instanceName;
                /** @type {?} */
                var data = event.dataTransfer.getData('data');
                /** @type {?} */
                var dragData = void 0;
                try {
                    dragData = JSON.parse(data).dd;
                    if (this.ngxDropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                        event.target.classList.remove(this.dragDropService.instanceName);
                        this.ngxDroppable.emit({ dragTag: dragTag, dragData: dragData, dropData: this.ngxDropData });
                    }
                }
                catch (e) {
                    if (console && typeof console.log === 'function') {
                        console.log(e);
                        console.log('Drop failed! Data: ', data);
                    }
                }
            }
        };
        NgxDroppableDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxDroppable]'
                    },] }
        ];
        /** @nocollapse */
        NgxDroppableDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: NgxDragDropService }
        ]; };
        NgxDroppableDirective.propDecorators = {
            ngxDroppable: [{ type: core.Output }],
            ngxDropTags: [{ type: core.Input }],
            ngxDropData: [{ type: core.Input }],
            onDragEnter: [{ type: core.HostListener, args: ['dragenter', ['$event'],] }],
            onDragOver: [{ type: core.HostListener, args: ['dragover', ['$event'],] }],
            onDragLeave: [{ type: core.HostListener, args: ['dragleave', ['$event'],] }],
            onDrop: [{ type: core.HostListener, args: ['drop', ['$event'],] }]
        };
        return NgxDroppableDirective;
    }());
    if (false) {
        /** @type {?} */
        NgxDroppableDirective.prototype.ngxDroppable;
        /** @type {?} */
        NgxDroppableDirective.prototype.ngxDropTags;
        /** @type {?} */
        NgxDroppableDirective.prototype.ngxDropData;
        /**
         * @type {?}
         * @private
         */
        NgxDroppableDirective.prototype.el;
        /**
         * @type {?}
         * @private
         */
        NgxDroppableDirective.prototype.dragDropService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxDragDropModule = /** @class */ (function () {
        function NgxDragDropModule() {
        }
        NgxDragDropModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [],
                        declarations: [
                            NgxDraggableDirective,
                            NgxDroppableDirective
                        ],
                        exports: [
                            NgxDraggableDirective,
                            NgxDroppableDirective
                        ]
                    },] }
        ];
        return NgxDragDropModule;
    }());

    exports.NgxDragDropModule = NgxDragDropModule;
    exports.NgxDragDropService = NgxDragDropService;
    exports.NgxDraggableDirective = NgxDraggableDirective;
    exports.NgxDroppableDirective = NgxDroppableDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-dragdrop.umd.js.map
